doinst() {
if [ -n "$(grep vendor /proc/cpuinfo | grep AMD)" ]; then
	for module in powernow_k6 powernow_k7 powernow_k8; do
		if [ -z "$( modprobe $module 2>&1 )" ]; then
			driver=${module}
			break
		fi
	done
elif [ -n "$(grep vendor /proc/cpuinfo | grep Intel)" ]; then
	for module in acpi_cpufreq speedstep_centrino p4_clockmod; do
		if [ -z "$( modprobe $module 2>&1 )" ]; then
			driver=${module}
			break
		fi
	done
fi

rmmod -f $driver
unset ext_new
if [ -e etc/rc.d/rc.powerthend.new ]; then
	ext_new=".new"
fi
sed "s/#driverfixme/driver=${driver}/" -i etc/rc.d/rc.powerthend$ext_new
}

config() {
  NEW="$1"
  OLD="`dirname $NEW`/`basename $NEW .new`"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then # toss the redundant
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

doinst
config etc/rc.d/rc.powerthend.new
